
const {
    Api,
    JsonRpc,
    ecc
} = require('lcnjs')
const ScatterExplorer = require('./ScatterExplorer')
const ScatterDapp = require('./ScatterDapp')
class Scatter {
    constructor() {
    }

    static getDevice() {
        if (window) {
            const u = window.navigator.userAgent;
            if (!!u.match(/AppleWebKit.*Mobile.*/)) {
                return 'mob'
            } else {
                return 'pc'
            }
        }
    }
    
    getDevice() {
        if (window) {
            const u = window.navigator.userAgent;
            if (!!u.match(/AppleWebKit.*Mobile.*/)) {
                return 'mob'
            } else {
                return 'pc'
            }
        }
    }
    async getInfo() {
        const device = this.getDevice()
        if (device === 'pc') {
            return await ScatterExplorer.getInfo()
        } else if (device === 'mob') {
            return await ScatterDapp.getInfo()
        } else {
            return Promise.reject('当前环境不支持')
        }
    }

    async getLcn() {
        const device = this.getDevice()
    
        return new Promise((resolve, reject) => {
            if (device === 'pc') {
                if (callback && typeof callback == 'function') {
                    return ScatterExplorer.loadScatter()
                } else {
                    return ScatterExplorer.loadScatter()
                }
            } else if (device === 'mob') {
                return ScatterDapp.loadScatter()
            } else {
                return reject('当前环境不支持')
            }
        })
    }

}

module.exports = Scatter